% EMO MARKOV TOOL - EXPECTED CONVERGENCE TIME OF (1+1)-UTITILY-BASED IMEA ON FISH-LANDSCAPE

clear;

a(1,2)= 1;
a(1,3)= 1;
a(2,4)= 1;
a(2,6)= 1;
a(2,1)= 1;
a(3,6)= 1;
a(3,5)= 1;
a(3,1)= 1;
a(4,7)= 1;
a(4,2)= 1;
a(5,3)= 1;
a(5,8)= 1;
a(6,7)= 1;
a(6,8)= 1;
a(6,2)= 1;
a(6,3)= 1;
a(7,4)= 1;
a(7,6)= 1;
a(7,9)= 1;
a(8,5)= 1;
a(8,6)= 1;
a(8,9)= 1;
a(9,7)= 1;
a(9,8)= 1;
a(9,10)= 1;
a(9,11)= 1;
a(10,9)= 1;
a(10,12)= 1;
a(11,9)= 1;
a(11,12)= 1;
a(12, 10)=1;
a(12, 11)=1;

f1(1)=4;
f1(2)=5;
f1(3)=2;
f1(4)=6;
f1(5)=0;
f1(6)=3;
f1(7)=4;
f1(8)=1;
f1(9)=2;
f1(10)=3;
f1(11)=0;
f1(12)=1;

f2(1)=4;
f2(2)=2;
f2(3)=5;
f2(4)=0;
f2(5)=6;
f2(6)=3;
f2(7)=1;
f2(8)=4;
f2(9)=2;
f2(10)=0;
f2(11)=3;
f2(12)=1;

L=12;

% compute neighborhoodsize for each node
for i=1:L
 c=0;
 for j=1:L
   if (a(i,j)==1) 
     c = c + 1;
   end
 end
   nbsize(i)=c;
end

for i=1:L
 c=0;
 for j=1:L
   if (a(i,j)==1 && ...
     ((f1(i)+f2(i) < (f1(j)+f2(j)))))
     %Parent dominate offspring
     c = c + 1;
   end
 end
   ndominated(i)=c;
end

for i=1:L
 c=0;
 for j=1:L
   if (a(i,j)==1 && ...
     ((f1(j) + f2(j) < f1(i)+f2(i))))
     
     %Offspring dominates parent
     c = c + 1;
     
   end
 end
   ndominating(i)=c;
end

for i=1:L
  nindifferent(i)=nbsize(i)-ndominating(i)-ndominated(i);
end

PSelChild=0;
PMut=0;

for i=1:L
  for j=1:L
    % The non-connected nodes: p_ij=0
    if (a(i,j)==0 && i~= j)
      TKernel(i,j)=0;
    end
    if (a(i,j)==1 && i ~= j)
      PMut= 1/(nbsize(i)+1);
      % i dominates j (min,min)
      if ((f1(i) + f2(i)) < (f1(j)+f2(j))) 
        PSelChild=0;
      elseif (f1(j) +f2(j) < f1(i)+f2(i))
        PSelChild=1;
      else
        PSelChild=1/2;
      end
      TKernel(i,j)=PMut*PSelChild;
    end
    if (i==j)
      PMut=1/(nbsize(i)+1);
      TKernel(i,j)=PMut+PMut*ndominated(i)+1/2*PMut*nindifferent(i);
    end
  end
end
  
  

% initial state
for i=1:L
  p(i)=0;%1/L;
end
p(1) = 1;

pnew=p;
for index = 1 : 1000
  pnew= pnew * TKernel;
end


% 
% d = 3;
% 
% 
% plot2d(pnew);







